#region Copyright Syncfusion Inc. 2001-2018.
// Copyright Syncfusion Inc. 2001-2018. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using DemoCommon.Grid;
using Syncfusion.Data;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Enums;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataBinding
{
    public partial class Form1 : Form
    {
        #region Fields
        #endregion

        #region Constructor
        public Form1()
        {
            InitializeComponent();

            sfDataGrid1.AutoGenerateColumns = false;
            sfDataGrid1.DataSource = GetCollection();

            sfDataGrid1.Columns.Add(new GridNumericColumn() { MappingName = "ProductID" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "ProductName" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "Category.CategoryName" });
            sfDataGrid1.Columns.Add(new GridNumericColumn() { MappingName = "UnitPrice" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "Status" });
        }

        private ObservableCollection<Product> GetCollection()
        {
            ObservableCollection<Product> items = new ObservableCollection<Product>();

            items.Add(new Product() { ProductID = 1, ProductName = "Grape", UnitPrice = 35, Status = "Available", Category = new Category() { CategoryName = "Fruits" } });
            items.Add(new Product() { ProductID = 2, ProductName = "Orange", UnitPrice = 45, Status = "Available", Category = new Category() { CategoryName = "Fruits" } });
            items.Add(new Product() { ProductID = 3, ProductName = "Lemon", UnitPrice = 78, Status = "Available", Category = new Category() { CategoryName = "Fruits" } });
            items.Add(new Product() { ProductID = 4, ProductName = "Pineapple", UnitPrice = 125, Status = "Available", Category = new Category() { CategoryName = "Fruits" } });
            items.Add(new Product() { ProductID = 5, ProductName = "Egg", UnitPrice = 35, Status = "Available", Category = new Category() { CategoryName = "Food" } });
            items.Add(new Product() { ProductID = 6, ProductName = "Avacado", UnitPrice = 35, Status = "Available", Category = new Category() { CategoryName = "Fruits" } });

            return items;

        }
        #endregion

    }

    public class Product
    {
        public int ProductID { get; set; }
        public string ProductName { get; set; }
        public Category Category { get; set; }
        public decimal UnitPrice { get; set; }
        public string Status { get; set; }
    }

    public class Category
    {
        public int CategoryID { get; set; }
        public string CategoryName { get; set; }
        public IList<Product> Products { get; set; }
    }
}
